//
// Copyright (C) 1999-2002 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <win/WSDwinAppDev.h>
#include <win/WSDwinColor.h>
#include <win/WSDwinMouse.h>
#include <WSCcolorSet.h>
#include <win/WSDwindraw.h>
#include <WSDdev.h>

HINSTANCE hInst;
char szAppName[] = "Wide Studio Application";
char szTitle[]= "Wide Studio Application";

extern LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM uParam,LPARAM lParam);
//extern "C" {
//int WINAPI _cygwin_dll_entry(HANDLE h,DWORD reason,void* foo){
//  return 1;
//};
//};
BOOL InitApplication(HINSTANCE hInstance){
  WNDCLASS wc;
//  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.style = CS_HREDRAW | CS_VREDRAW | CS_SAVEBITS;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = (HICON)::LoadImage(NULL,"main.ico",IMAGE_ICON,0,0,LR_LOADFROMFILE);
WSMFtrace("XXZZim1 WinMan1 icon=0x%x  hinst=0x%x\n",wc.hIcon,hInstance);
  if (wc.hIcon == NULL){
    wc.hIcon = LoadIcon(hInstance,(char*)101);
WSMFtrace("XXZZim1 WinMan2 icon=0x%x\n",wc.hIcon);
//    wc.hIcon = LoadIcon(hInstance,szAppName);
//    wc.hIcon = (HICON)::LoadImage(hInstance,(char*)101,IMAGE_ICON,0,0,LR_DEFAULTCOLOR);
  }
  wc.hCursor = LoadCursor(NULL,IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW +1);
  wc.lpszMenuName = szAppName;
  wc.lpszClassName = szAppName;
  return RegisterClass(&wc);
}

HWND hWnd;
BOOL InitInstance(HINSTANCE hInstance,int nCmdShow){
  hInst = hInstance;
  hWnd = CreateWindow(szAppName,szTitle,WS_OVERLAPPEDWINDOW,
                 CW_USEDEFAULT,0,
                 CW_USEDEFAULT,0,
                 NULL,NULL,
                 hInstance,NULL);
  if (!hWnd) return FALSE;
//  ShowWindow(hWnd,nCmdShow);
//  UpdateWindow(hWnd);
  return TRUE;
}
extern "C" {
//int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
int _win_main(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){

  WSDdev::setDraw(new WSDwindraw());

WSMFtrace("main start:\n");
  if (!hPrevInstance){
    if (!InitApplication(hInstance)){
      return (FALSE);
    }
  }
  if (!InitInstance(hInstance,nCmdShow)){
    return FALSE;
  }

  WSDwinAppDev* winApp = WSGIwinAppDev();
  winApp->setInitPrm(lpCmdLine);
  winApp->setWnd(hWnd);
  winApp->setInstanceHandle(hInstance);
  winApp->initialize();


   WSGIwinAppMouse()->initialize();
WSMFtrace("main 1:\n");

   winApp->execInitHandler();
WSMFtrace("main 2:\n");

   winApp->handleEvents();
   return 0;
}
};
